*MK_SFS4.prg
*Purpose: to create a bash script which in turn
*creates an .sfs or .pet sourcedir for Puppy Linux.
*Language: Clipper Summer '87.
*Author: P.N. Courier, "Sit Heel Speak" on the Puppy Linux forum.
*Copyright 2009-2010 by P.N.Courier
*License: released under the terms of LGPL3.
*
* MK_SFS4.prg checks for files existing in the old but not in the new.
*
*
* Clipper housekeeping:
*
clear typeahead		&& clear the keyboard buffer
close all			&& close any open .dbf and .ntx files
close proc			&& close any open procedure files
clear memory		&& deallocate any open memory variables
vga(50)			&& enable the dmvga101 library,
				&&  to enable Clipper to use a 50-line
				&&  DOS window's full area
letbright(.t.)		&& enable bright colors
set color to W/B,N/W,B,B	&& white text on blue background
*
set scoreboard off	&& turn off program status bar at line 0
altd(1)				&& turn on the Clipper debugger (Alt-D)
setcancel(.t.)		&& allow script to be halted using Alt-C
*
*
*
start_date=date()
start_time=time()
@ 17,0 say "Starting MK_SFS4 (checks for vanished oldtree contents). Time: "
@ 17,col() say start_time
@ 18,0 say "Indexing newtree..."

select 10
use newtree.dbf
index on newtree->identity99 to newtree.ntx

select 20  && oldtree.dbf
use oldtree.dbf

select 30
use treediff.dbf

select 20 && oldtree
go top
@ 19,0 say "Record number in oldtree comparing:"

do while.not.eof()

@ 19,37 say recno()

select 10  && newtree.dbf
toseek=oldtree->identity99
seek m->toseek

if .not.found()
select 30 && treediff
append blank
replace treediff->difference with "In old, not in new"
replace treediff->identity with oldtree->identity
replace treediff->identity99 with treediff->identity
replace treediff->oldsize with "Old: "+oldtree->size
replace treediff->oldtd with "Old: "+oldtree->timedate
replace treediff->newsize with "New: not in"
replace treediff->newtd with "New: not in"
endif

select 20 && oldtree
skip
enddo

close all

end_date=date()
end_time=time()
time4=realtime(end_date,end_time)-realtime(start_date,start_time)
restore from savemems additive
save to savemems

@ 20,0 say "Finished MK_SFS4, no errors, in "+commas(time4)+" seconds."
@ 21,78 say "" 	&& for neatness, positions cursor for C:> prompt.

retu

* There must be some kind-a way out-ta here,
* Said a junkie to a thief...

********************************************
function commas
parameter input

if type("input")=="N"
if int(input)<>input
input=ltri(str(input,15,3))
else
input=ltri(str(input,15,0))
endif
endif

if type("input")=="C"
if val(input)<1000.and.val(input)>(-999.999)
return input
endif
endif && of if type("input")=="C"

len_w_pads=len(input)
inputx=alltrim(input)
rightpart=iif("."$inputx,right(inputx,len(inputx)-(at(".",inputx)-1)),"")
leftpart=iif("."$inputx,left(inputx,at(".",inputx)-1),inputx)
lenlp=len(leftpart)

if lenlp>0
declare backward[lenlp]
countx2=lenlp
do while countx2>0
afill(backward,substr(leftpart,countx2,1),(lenlp-countx2+1),1)
countx2=countx2-1
enddo

*A backward image of leftpart is now in backward.
bwwcommas=""
countx2=1

do while countx2<=lenlp
bwwcommas=bwwcommas+backward[countx2]
if (int(countx2/3))==(countx2/3)
bwwcommas=bwwcommas+","
endif
countx2=countx2+1
enddo

*bwwcommas now contains a backward image of alltrim(the original),
* with commas.

lenbwwc=len(bwwcommas)
leftpart=""
countx2=lenbwwc

do while countx2>0
leftpart=leftpart+substr(bwwcommas,countx2,1)
countx2=countx2-1
enddo

endif && of if lenlp>0

output=leftpart+rightpart

*Now rid leading zeroes
lenop=len(output)
declare digit[len(output)]
countx2=1

do while countx2<=lenop
afill(digit,substr(output,countx2,1),countx2,1)
countx2=countx2+1
enddo
countx2=1

do while digit[countx2]$"0,"
afill(digit," ",countx2,1)
countx2=countx2+1
enddo

countx2=1
output=""

do while countx2<=lenop
output=output+digit[countx2]
countx2=countx2+1
enddo

output=alltrim(output)
if "-,"$output
output=strtran(output,"-,","-")
endif

if len(output)<len_w_pads
output=space(len_w_pads-len(output))+output
endif

return output

********************************************
function realtime
parameters the_date,the_time

orig_date=ctod("01/01/1980")
date_secs=(the_date-orig_date)*86400
hour_secs=val(substr(the_time,1,2))*3600
min_secs=val(substr(the_time,4,2))*60
secs=val(substr(the_time,7,2))

return date_secs + hour_secs + min_secs + secs

